package 
{
	import com.events.XMLLoaderEvent;
	import com.net.XMLLoader;
	
	import flash.display.Sprite;
	import flash.events.*;
	import flash.net.*;
	import flash.system.System;
	import flash.text.TextField;

	public class XMLLoaderTest extends Sprite
	{
		// things on fla.
		public var txtConsol: TextField;
		
		// this file is encoded by EUC-KR format. (not utf-8);
		public const PATH: String = "http://www.as3.kr/font_list.xml";
		
		public function XMLLoaderTest()
		{
//			// test URLLoader.
			this.loadTest1();
			
			// test XMLLoader.
//			this.loadTest2();
		}
		
		private var urlLoader: URLLoader;
		private function loadTest1(): void
		{
			System.useCodePage = true;
			
			this.urlLoader = new URLLoader();
			this.urlLoader.addEventListener( Event.COMPLETE, loadTest1Complete );
			this.urlLoader.addEventListener( SecurityErrorEvent.SECURITY_ERROR, loadTest1SecurityError );
			this.urlLoader.load( new URLRequest( PATH ) );
		}
		
		private function loadTest1SecurityError( e: Event ): void
		{
			output( "security error." );
		}
		
		private function loadTest1Complete( e: Event ): void
		{
			try
			{
				output( XML( this.urlLoader.data ).toXMLString() );
				output( "XML parse complete" );
			}
			catch( e: TypeError )
			{
				output( this.urlLoader.data );
				output();
				output( "XML Parse error." );
				output();
			}
		}
		
		private var xmlLoader: XMLLoader;
		private function loadTest2(): void
		{
			this.xmlLoader = new XMLLoader();
			this.xmlLoader.addEventListener( XMLLoaderEvent.LOAD_COMPLETE, loadTest2Complete );
			this.xmlLoader.addEventListener( XMLLoaderEvent.LOAD_FAIL, loadTest2Fail );
			this.xmlLoader.url = PATH;
			this.xmlLoader.encode = "euc-kr";
			this.xmlLoader.load();
		}
		
		private function loadTest2Complete( e: XMLLoaderEvent ): void
		{
			output( this.xmlLoader.xml.toXMLString() );
		}
		
		private function loadTest2Fail( e: XMLLoaderEvent ): void
		{
			output( "load fail by " + e.errorReason );
		}
		
		public function output( message: String = "" ): void
		{
			this.txtConsol.appendText( "\n" + message );
			this.txtConsol.scrollV = this.txtConsol.maxScrollV;
		}
	}
}
