package com.net
{
	import com.events.XMLLoaderEvent;
	
	import flash.events.*;
	
	// set "type" to your package path.
	[Event ( name = "loadComplete", type = "com.events.XMLLoaderEvent" ) ]
	[Event ( name = "loadFail", type = "com.events.XMLLoaderEvent" ) ]
	[Event ( name = "progress", type = "flash.events.ProgressEvent" ) ]
	
	public class XMLLoader extends AbstractLoader implements IEventDispatcher
	{
		public function XMLLoader(){}
		
		public var encode: String = "utf-8";
		
		private var _xml: XML;
		public function get xml(): XML
		{
			return this._xml;
		}
		
		override protected function loadComplete( e: Event ): void
		{
			try
			{
				this._xml = XML( this.loader.readMultiByte( this.loader.bytesAvailable, this.encode ) );
			}
			catch( e: TypeError )
			{
				this.dispatchEvent( new XMLLoaderEvent( XMLLoaderEvent.LOAD_FAIL, "parse error" ) );
				return;
			}
			
			this.dispatchEvent( new XMLLoaderEvent( XMLLoaderEvent.LOAD_COMPLETE ) );
		}
		
		override protected function loadFailSecurity( e: Event ): void
		{
			this.dispatchEvent( new XMLLoaderEvent( XMLLoaderEvent.LOAD_FAIL, "Security Error." ) );
		}
		
		override protected function loadFailIO( e: Event ): void
		{
			this.dispatchEvent( new XMLLoaderEvent( XMLLoaderEvent.LOAD_FAIL, "File IOError." ) );
		}
	}
}